=== debian/changelog ===
xnnpack (0.0~git20200425.54f5917-2) unstable; urgency=medium

  * Fixup the clog patch (it was empty in the previous upload due to mistake)
  * Apply wrap-and-srot.
  * Create symbols control file for libXNNPACK.so
  * List not-installed files.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Wed, 29 Apr 2020 09:27:23 +0800

xnnpack (0.0~git20200425.54f5917-1) experimental; urgency=medium

  * Initial release. (Closes: #958818)

 -- Mo Zhou <lumin@debian.org>  Sun, 26 Apr 2020 15:04:57 +0800
