=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening+=all
%:
	dh $@ -Scmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_SHARED_LIBS=ON \
		-DXNNPACK_USE_SYSTEM_LIBS=ON \
		-DXNNPACK_BUILD_TESTS=OFF \
		-DXNNPACK_BUILD_BENCHMARKS=OFF \
		-DGOOGLETEST_SOURCE_DIR=/usr/src/googletest

override_dh_auto_test:
	-dh_auto_test
