=== debian/changelog ===
xnnpack (0.0~git20200827.37297a6-1) unstable; urgency=medium

  * New upstream version 0.0~git20200827.37297a6
  * Remove 533.patch (merged upstream) and refresh the remaining ones.
  * Refresh symbols control file.

 -- Mo Zhou <lumin@debian.org>  Thu, 03 Sep 2020 10:37:10 +0800

xnnpack (0.0~git20200425.54f5917-4) unstable; urgency=medium

  * Strip and embedded clog and remove the corresponding patch.
  * Bump debhelper compat level to 13.
  * Remove README.Source, as the embedded clog has been removed.

 -- Mo Zhou <lumin@debian.org>  Fri, 01 May 2020 14:11:14 +0800

xnnpack (0.0~git20200425.54f5917-3) unstable; urgency=medium

  * Make the symbols control file amd64-only.
  * Override dh_dwz and allow it to fail on arm64.

 -- Mo Zhou <lumin@debian.org>  Thu, 30 Apr 2020 11:42:31 +0800
