## xnnpack 0.0~git20201031.beca652

=== CMakeLists.txt ===
--- 
+++ 
@@ -172,6 +172,7 @@
   src/operators/leaky-relu-nc.c
   src/operators/max-pooling-nhwc.c
   src/operators/prelu-nc.c
+  src/operators/resize-bilinear-nchw.c
   src/operators/resize-bilinear-nhwc.c
   src/operators/sigmoid-nc.c
   src/operators/softmax-nc.c
@@ -190,8 +191,8 @@
   src/subgraph/deconvolution-2d.c
   src/subgraph/depthwise-convolution-2d.c
   src/subgraph/divide.c
+  src/subgraph/floor.c
   src/subgraph/fully-connected.c
-  src/subgraph/floor.c
   src/subgraph/global-average-pooling-2d.c
   src/subgraph/hardswish.c
   src/subgraph/leaky-relu.c
@@ -203,12 +204,12 @@
   src/subgraph/prelu.c
   src/subgraph/sigmoid.c
   src/subgraph/softmax.c
+  src/subgraph/square-root.c
+  src/subgraph/square.c
+  src/subgraph/squared-difference.c
   src/subgraph/static-constant-pad.c
   src/subgraph/static-reshape.c
   src/subgraph/static-resize-bilinear-2d.c
-  src/subgraph/square.c
-  src/subgraph/square-root.c
-  src/subgraph/squared-difference.c
   src/subgraph/subtract.c
   src/subgraph/unpooling-2d.c)
 
@@ -219,8 +220,8 @@
 SET(XNNPACK_COLD_SRCS ${XNNPACK_OPERATOR_SRCS} ${XNNPACK_SUBGRAPH_SRCS} ${XNNPACK_LOGGING_SRCS})
 LIST(APPEND XNNPACK_COLD_SRCS
   src/init.c
+  src/memory-planner.c
   src/memory.c
-  src/memory-planner.c
   src/operator-delete.c
   src/runtime.c
   src/subgraph.c
@@ -228,12 +229,14 @@
 
 SET(XNNPACK_HOT_SRCS
   src/indirection.c
-  src/packing.c
-  src/operator-run.c)
+  src/operator-run.c
+  src/packing.c)
 
 SET(XNNPACK_TABLE_SRCS
   src/tables/exp2-k-over-64.c
-  src/tables/exp2-k-over-2048.c)
+  src/tables/exp2-k-over-2048.c
+  src/tables/exp2minus-k-over-64.c
+  src/tables/exp2minus-k-over-2048.c)
 
 SET(XNNPACK_SCALAR_MICROKERNEL_SRCS
   src/f32-argmaxpool/4x-scalar-c1.c
@@ -244,42 +247,36 @@
   src/f32-clamp/gen/scalar-x1.c
   src/f32-clamp/gen/scalar-x2.c
   src/f32-clamp/gen/scalar-x4.c
+  src/f32-conv-hwc/3x3s2p0p1c3x4-scalar-1x1.c
   src/f32-conv-hwc/3x3s2p1c3x4-scalar-1x1.c
-  src/f32-conv-hwc/3x3s2p0p1c3x4-scalar-1x1.c
   src/f32-conv-hwc2chw/3x3s2p1c3x4-scalar-1x1.c
-  src/f32-dwconv-chw/3x3p1-scalar.c
-  src/f32-dwconv-chw/3x3s2p1-scalar.c
-  src/f32-dwconv-chw/5x5p2-scalar.c
-  src/f32-dwconv-chw/5x5s2p2-scalar.c
+  src/f32-dwconv/gen/up1x4-minmax-scalar-acc2.c
+  src/f32-dwconv/gen/up1x4-minmax-scalar.c
+  src/f32-dwconv/gen/up1x4-scalar-acc2.c
   src/f32-dwconv/gen/up1x4-scalar.c
-  src/f32-dwconv/gen/up1x4-scalar-acc2.c
+  src/f32-dwconv/gen/up1x9-minmax-scalar-acc2.c
+  src/f32-dwconv/gen/up1x9-minmax-scalar.c
+  src/f32-dwconv/gen/up1x9-scalar-acc2.c
   src/f32-dwconv/gen/up1x9-scalar.c
-  src/f32-dwconv/gen/up1x9-scalar-acc2.c
+  src/f32-dwconv/gen/up1x25-minmax-scalar-acc2.c
+  src/f32-dwconv/gen/up1x25-minmax-scalar.c
+  src/f32-dwconv/gen/up1x25-scalar-acc2.c
   src/f32-dwconv/gen/up1x25-scalar.c
-  src/f32-dwconv/gen/up1x25-scalar-acc2.c
+  src/f32-dwconv/gen/up2x4-minmax-scalar-acc2.c
+  src/f32-dwconv/gen/up2x4-minmax-scalar.c
+  src/f32-dwconv/gen/up2x4-scalar-acc2.c
   src/f32-dwconv/gen/up2x4-scalar.c
-  src/f32-dwconv/gen/up2x4-scalar-acc2.c
+  src/f32-dwconv/gen/up2x9-minmax-scalar-acc2.c
+  src/f32-dwconv/gen/up2x9-minmax-scalar.c
+  src/f32-dwconv/gen/up2x9-scalar-acc2.c
   src/f32-dwconv/gen/up2x9-scalar.c
-  src/f32-dwconv/gen/up2x9-scalar-acc2.c
+  src/f32-dwconv/gen/up2x25-minmax-scalar-acc2.c
+  src/f32-dwconv/gen/up2x25-minmax-scalar.c
+  src/f32-dwconv/gen/up2x25-scalar-acc2.c
   src/f32-dwconv/gen/up2x25-scalar.c
-  src/f32-dwconv/gen/up2x25-scalar-acc2.c
-  src/f32-dwconv/gen/up1x4-minmax-scalar.c
-  src/f32-dwconv/gen/up1x4-minmax-scalar-acc2.c
-  src/f32-dwconv/gen/up1x9-minmax-scalar.c
-  src/f32-dwconv/gen/up1x9-minmax-scalar-acc2.c
-  src/f32-dwconv/gen/up1x25-minmax-scalar.c
-  src/f32-dwconv/gen/up1x25-minmax-scalar-acc2.c
-  src/f32-dwconv/gen/up2x4-minmax-scalar.c
-  src/f32-dwconv/gen/up2x4-minmax-scalar-acc2.c
-  src/f32-dwconv/gen/up2x9-minmax-scalar.c
-  src/f32-dwconv/gen/up2x9-minmax-scalar-acc2.c
-  src/f32-dwconv/gen/up2x25-minmax-scalar.c
-  src/f32-dwconv/gen/up2x25-minmax-scalar-acc2.c
-  src/f32-gavgpool-cw/scalar-x1.c
-  src/f32-gavgpool/7p7x-minmax-scalar-c1.c
-  src/f32-gavgpool/7x-minmax-scalar-c1.c
-  src/f32-gemm/gen/1x4-scalar.c
-  src/f32-gemm/gen/2x4-scalar.c
-  src/f32-gemm/gen/4x2-scalar.c
-  src/f32-gemm/gen/4x4-scalar.c
-  src/f32-gemm/gen/1x4-relu-scalar.c
+  src/f32-dwconv2d-chw/gen/3x3p1-minmax-scalar-1x1-acc2.c
+  src/f32-dwconv2d-chw/gen/3x3p1-minmax-scalar-1x1-acc3.c
+  src/f32-dwconv2d-chw/gen/3x3p1-minmax-scalar-1x1-acc4.c
+  src/f32-dwconv2d-chw/gen/3x3p1-minmax-scalar-1x1.c
+  src/f32-dwconv2d-chw/gen/3x3p1-minmax-scalar-2x1-acc2.c
+  src/f32-dwconv2d-chw/gen/3x3p1-minmax-scalar-2x1.c
