=== debian/changelog ===
xnnpack (0.0~git20201031.beca652-1) unstable; urgency=medium

  * New upstream snapshot 0.0~git20201031.beca652
  * Change maintainer into Debian Deep Learning Team <debian-ai@l.d.o>.
  * Refresh symbols list for amd64 architecture.

 -- Mo Zhou <lumin@debian.org>  Mon, 02 Nov 2020 16:02:16 +0800
