=== debian/changelog ===
xnnpack (0.0~git20201031.beca652+really.git20200323.1b35463-2) unstable; urgency=medium

  * Don't install unwanted header files.
  * Revert "Remove 533.patch (merged upstream) and refresh the remaining ones."
    We need this patch again due to the rollback.

 -- Mo Zhou <lumin@debian.org>  Fri, 11 Dec 2020 13:50:30 +0800

xnnpack (0.0~git20201031.beca652+really.git20200323.1b35463-1) unstable; urgency=medium

  * Rollback to upstream snapshot 0.0~git20200323.1b35463
  * Please pin to this snapshot for PyTorch 1.7.0
  * Rebase existing patches.
  * Stop tracking symbols, and update not-installed list.

 -- Mo Zhou <lumin@debian.org>  Fri, 11 Dec 2020 12:33:46 +0800
